import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

// Autor: %AUTHOR%
// Datum: %DATE%

public class TodoListeGUI extends JFrame {
  // Anfang Attribute
  private JLabel lAktAufgabe = new JLabel();
  private JTextField tfAktAufgabe = new JTextField();
  private JButton btAnfang = new JButton();
  private JButton btWeiter = new JButton();
  private JButton btEnde = new JButton();
  private JButton btAendern = new JButton();
  private JButton btLoeschen = new JButton();
  private JLabel lNeueAufgabe = new JLabel();
  private JTextField tfNeueAufgabe = new JTextField();
  private JButton btDavor = new JButton();
  private JButton btDanach = new JButton();
  private JTextArea taAlleAufgaben = new JTextArea("");
  private JScrollPane taAlleAufgabenScrollPane = new JScrollPane(taAlleAufgaben);
  // Ende Attribute
  private TodoListe liste = new TodoListe();

  public TodoListeGUI(String title) { 
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 703; 
    int frameHeight = 340;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    lAktAufgabe.setBounds(8, 8, 254, 20);
    lAktAufgabe.setText("Aktuelle Aufgabe");
    cp.add(lAktAufgabe);
    tfAktAufgabe.setBounds(8, 32, 257, 25);
    cp.add(tfAktAufgabe);
    btAnfang.setBounds(8, 64, 75, 25);
    btAnfang.setText("|<");
    btAnfang.setMargin(new Insets(2, 2, 2, 2));
    btAnfang.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btAnfang_ActionPerformed(evt);
        }
      });
    cp.add(btAnfang);
    btWeiter.setBounds(96, 64, 75, 25);
    btWeiter.setText(">");
    btWeiter.setMargin(new Insets(2, 2, 2, 2));
    btWeiter.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btWeiter_ActionPerformed(evt);
        }
      });
    cp.add(btWeiter);
    btEnde.setBounds(192, 64, 75, 25);
    btEnde.setText(">|");
    btEnde.setMargin(new Insets(2, 2, 2, 2));
    btEnde.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btEnde_ActionPerformed(evt);
        }
      });
    cp.add(btEnde);
    btAendern.setBounds(8, 96, 259, 25);
    btAendern.setText("aendern");
    btAendern.setMargin(new Insets(2, 2, 2, 2));
    btAendern.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btAendern_ActionPerformed(evt);
        }
      });
    btAendern.setEnabled(true);
    cp.add(btAendern);
    btLoeschen.setBounds(8, 128, 259, 25);
    btLoeschen.setText("loeschen");
    btLoeschen.setMargin(new Insets(2, 2, 2, 2));
    btLoeschen.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btLoeschen_ActionPerformed(evt);
        }
      });
    cp.add(btLoeschen);
    lNeueAufgabe.setBounds(8, 160, 262, 20);
    lNeueAufgabe.setText("Neue Aufgabe");
    cp.add(lNeueAufgabe);
    tfNeueAufgabe.setBounds(8, 184, 262, 28);
    cp.add(tfNeueAufgabe);
    btDavor.setBounds(8, 224, 259, 25);
    btDavor.setText("davor einfuegen");
    btDavor.setMargin(new Insets(2, 2, 2, 2));
    btDavor.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btDavor_ActionPerformed(evt);
        }
      });
    cp.add(btDavor);
    btDanach.setBounds(8, 264, 259, 25);
    btDanach.setText("danach einfuegen");
    btDanach.setMargin(new Insets(2, 2, 2, 2));
    btDanach.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btDanach_ActionPerformed(evt);
        }
      });
    cp.add(btDanach);
    taAlleAufgabenScrollPane.setBounds(304, 8, 369, 281);
    cp.add(taAlleAufgabenScrollPane);
    // Ende Komponenten

    setVisible(true);
  } // end of public TodoListeGUI

  // Anfang Methoden

  public static void main(String[] args) {
    new TodoListeGUI("TodoListeGUI");
  } // end of main

  public void btAnfang_ActionPerformed(ActionEvent evt) {
    liste.zumAnfang();
    tfAktAufgabe.setText(liste.zeigeAktuelleAufgabe());
    if (tfAktAufgabe.getText().equals("") || tfAktAufgabe.getText().equals("---") ) {
      btAendern.setEnabled(false);
      btLoeschen.setEnabled(false);
    } else {
      btAendern.setEnabled(true);
      btLoeschen.setEnabled(true);
    }

  } // end of btAnfang_ActionPerformed

  public void btWeiter_ActionPerformed(ActionEvent evt) {
    liste.weiter();
    tfAktAufgabe.setText(liste.zeigeAktuelleAufgabe());
    if (tfAktAufgabe.getText().equals("") || tfAktAufgabe.getText().equals("---") ) {
      btAendern.setEnabled(false);
      btLoeschen.setEnabled(false);
    } else {
      btAendern.setEnabled(true);
      btLoeschen.setEnabled(true);
    }
  } // end of btWeiter_ActionPerformed

  public void btEnde_ActionPerformed(ActionEvent evt) {
    liste.zumEnde();
    tfAktAufgabe.setText(liste.zeigeAktuelleAufgabe());
    if (tfAktAufgabe.getText().equals("") || tfAktAufgabe.getText().equals("---") ) {
      btAendern.setEnabled(false);
      btLoeschen.setEnabled(false);
    } else {
      btAendern.setEnabled(true);
      btLoeschen.setEnabled(true);
    }
  } // end of btEnde_ActionPerformed

  public void btAendern_ActionPerformed(ActionEvent evt) {
    liste.aendere(new Aufgabe(tfAktAufgabe.getText()));
    tfAktAufgabe.setText(liste.zeigeAktuelleAufgabe());
    taAlleAufgaben.setText(liste.zeigeAlles());
  } // end of btAendern_ActionPerformed

  public void btLoeschen_ActionPerformed(ActionEvent evt) {
    liste.loesche();
    tfAktAufgabe.setText(liste.zeigeAktuelleAufgabe());
    taAlleAufgaben.setText(liste.zeigeAlles());
    if (tfAktAufgabe.getText().equals("") || tfAktAufgabe.getText().equals("---") ) {
      btAendern.setEnabled(false);
      btLoeschen.setEnabled(false);
    } else {
      btAendern.setEnabled(true);
      btLoeschen.setEnabled(true);
    }
  } // end of btLoeschen_ActionPerformed

  public void btDavor_ActionPerformed(ActionEvent evt) {
    liste.ergaenzeDavor(new Aufgabe(tfNeueAufgabe.getText()));
    tfAktAufgabe.setText(liste.zeigeAktuelleAufgabe());
    taAlleAufgaben.setText(liste.zeigeAlles());
  } // end of btDavor_ActionPerformed

  public void btDanach_ActionPerformed(ActionEvent evt) {
    liste.ergaenzeDanach(new Aufgabe(tfNeueAufgabe.getText()));
    tfAktAufgabe.setText(liste.zeigeAktuelleAufgabe());
    taAlleAufgaben.setText(liste.zeigeAlles());
  } // end of btDanach_ActionPerformed

  // Ende Methoden
} // end of class TodoListeGUI
